package jerboatutorial1.modeler.Lesson1;


import java.util.List;
import java.util.ArrayList;
import up.jerboa.core.rule.*;
import up.jerboa.core.util.*;
import up.jerboa.core.*;
import up.jerboa.exception.JerboaException;

import jerboatutorial1.modeler.Modeler;
import jerboatutorial1.embeddings.Points;
import java.awt.Color;



/**
 * 
 */



public class CreateDart extends JerboaRuleGenerated {

    private transient JerboaRowPattern curleftPattern;


	// BEGIN PARAMETERS 

	protected Points myPoint;
	protected boolean askUser;

	// END PARAMETERS 



    public CreateDart(Modeler modeler) throws JerboaException {

        super(modeler, "CreateDart", "Lesson1");

        // -------- LEFT GRAPH

        // -------- RIGHT GRAPH
        JerboaRuleNode rn0 = new JerboaRuleNode("n0", 0, JerboaOrbit.orbit(), 3, new CreateDartExprRn0point(), new CreateDartExprRn0color());
        right.add(rn0);
        rn0.setAlpha(0, rn0);
        rn0.setAlpha(1, rn0);
        rn0.setAlpha(2, rn0);
        rn0.setAlpha(3, rn0);
;
        // ------- SPECIFIED FEATURE
        computeEfficientTopoStructure();
        computeSpreadOperation();
        // ------- USER DECLARATION 
        askUser = true;    }

    public int reverseAssoc(int i) {
        switch(i) {
        case 0: return -1;
        }
        return -1;
    }

    public int attachedNode(int i) {
        switch(i) {
        case 0: return -1;
        }
        return -1;
    }

    @Override
    public JerboaRuleResult applyRule(JerboaGMap gmap, JerboaInputHooks _hooks) throws JerboaException {
        JerboaRuleResult res = super.applyRule(gmap, _hooks);
        postprocess(gmap,res);
        return res;
    }
    public JerboaRuleResult applyRule(JerboaGMap gmap, Points myPoint, boolean askUser) throws JerboaException {
        JerboaInputHooksGeneric ____jme_hooks = new JerboaInputHooksGeneric();
        setMyPoint(myPoint);
        setAskUser(askUser);
        return applyRule(gmap, ____jme_hooks);
	}

    private class CreateDartExprRn0point implements JerboaRuleExpression {

        @Override
        public Object compute(JerboaGMap gmap, JerboaRuleOperation rule,JerboaRowPattern leftPattern, JerboaRuleNode rulenode) throws JerboaException {
            curleftPattern = leftPattern;
// ======== BEGIN CODE TRANSLATION FOR EXPRESSION COMPUTATION
            // ======== SEPARATION CODE TRANSLATION FOR EXPRESSION COMPUTATION
Points res = new 
Points(myPoint);
return res;
// ======== END CODE TRANSLATION FOR EXPRESSION COMPUTATION
        }

        @Override
        public String getName() {
            return "point";
        }

        @Override
        public int getEmbedding() {
            return ((Modeler)modeler).getPoint().getID();
        }
    }

    private class CreateDartExprRn0color implements JerboaRuleExpression {

        @Override
        public Object compute(JerboaGMap gmap, JerboaRuleOperation rule,JerboaRowPattern leftPattern, JerboaRuleNode rulenode) throws JerboaException {
            curleftPattern = leftPattern;
// ======== BEGIN CODE TRANSLATION FOR EXPRESSION COMPUTATION
            // ======== SEPARATION CODE TRANSLATION FOR EXPRESSION COMPUTATION
return new 
Color(0,200,0);
// ======== END CODE TRANSLATION FOR EXPRESSION COMPUTATION
        }

        @Override
        public String getName() {
            return "color";
        }

        @Override
        public int getEmbedding() {
            return ((Modeler)modeler).getColor().getID();
        }
    }

    @Override
    public boolean hasMidprocess() { return true; }
    @Override
    public boolean midprocess(JerboaGMap gmap, List<JerboaRowPattern> leftPattern) throws JerboaException {
	// BEGIN MIDPROCESS CODE
if(askUser) {
   myPoint = Points.askForCoords();
}
return true;

	// END MIDPROCESS CODE
    }

    @Override
    public boolean hasPostprocess() { return true; }
    @Override
    public void postprocess(JerboaGMap gmap, JerboaRuleResult res) throws JerboaException {
	// BEGIN POSTPROCESS CODE
askUser = true;

	// END POSTPROCESS CODE
    }

	public Points getMyPoint(){
		return myPoint;
	}
	public void setMyPoint(Points _myPoint){
		this.myPoint = _myPoint;
	}
	public boolean getAskUser(){
		return askUser;
	}
	public void setAskUser(boolean _askUser){
		this.askUser = _askUser;
	}
} // end rule Class