package jerboatutorial1.modeler.Lesson6;


import java.util.List;
import java.util.ArrayList;
import up.jerboa.core.rule.*;
import up.jerboa.core.util.*;
import up.jerboa.core.*;
import up.jerboa.exception.JerboaException;

import jerboatutorial1.modeler.Modeler;
import jerboatutorial1.embeddings.Points;
import java.awt.Color;
 // BEGIN HEADER IMPORT

import jerboatutorial1.Vectors;

 // END HEADER IMPORT



/**
 * 
 */



public class ExtrudeDart extends JerboaRuleGenerated {

    private transient JerboaRowPattern curleftPattern;


	// BEGIN PARAMETERS 

	protected Vectors myVector;
	protected boolean askUser;

	// END PARAMETERS 

 // BEGIN COPY PASTE OF HEADER



 // END COPY PASTE OF HEADER


    public ExtrudeDart(Modeler modeler) throws JerboaException {

        super(modeler, "ExtrudeDart", "Lesson6");

        // -------- LEFT GRAPH
        JerboaRuleNode ln0 = new JerboaRuleNode("n0", 0, JerboaOrbit.orbit(), 3);
        left.add(ln0);
        hooks.add(ln0);
        ln0.setAlpha(0, ln0);
        ln0.setAlpha(1, ln0);
        ln0.setAlpha(2, ln0);
        ln0.setAlpha(3, ln0);

        // -------- RIGHT GRAPH
        JerboaRuleNode rn0 = new JerboaRuleNode("n0", 0, JerboaOrbit.orbit(), 3, new ExtrudeDartExprRn0color());
        JerboaRuleNode rn1 = new JerboaRuleNode("n1", 1, JerboaOrbit.orbit(), 3, new ExtrudeDartExprRn1point());
        right.add(rn0);
        right.add(rn1);
        rn0.setAlpha(0, rn1);
        rn0.setAlpha(1, rn0);
        rn0.setAlpha(2, rn0);
        rn0.setAlpha(3, rn0);
        rn1.setAlpha(1, rn1);
        rn1.setAlpha(2, rn1);
        rn1.setAlpha(3, rn1);
;
        // ------- SPECIFIED FEATURE
        computeEfficientTopoStructure();
        computeSpreadOperation();
        // ------- USER DECLARATION 
 // BEGIN COPY PASTE OF HEADER

 // END COPY PASTE OF HEADER
        askUser = true;    }

    public int reverseAssoc(int i) {
        switch(i) {
        case 0: return 0;
        case 1: return -1;
        }
        return -1;
    }

    public int attachedNode(int i) {
        switch(i) {
        case 0: return 0;
        case 1: return 0;
        }
        return -1;
    }

    @Override
    public JerboaRuleResult applyRule(JerboaGMap gmap, JerboaInputHooks _hooks) throws JerboaException {
        JerboaRuleResult res = super.applyRule(gmap, _hooks);
        postprocess(gmap,res);
        return res;
    }
    public JerboaRuleResult applyRule(JerboaGMap gmap, JerboaDart n0, Vectors myVector, boolean askUser) throws JerboaException {
        JerboaInputHooksGeneric ____jme_hooks = new JerboaInputHooksGeneric();
        ____jme_hooks.addCol(n0);
        setMyVector(myVector);
        setAskUser(askUser);
        return applyRule(gmap, ____jme_hooks);
	}

    private class ExtrudeDartExprRn0color implements JerboaRuleExpression {

        @Override
        public Object compute(JerboaGMap gmap, JerboaRuleOperation rule,JerboaRowPattern leftPattern, JerboaRuleNode rulenode) throws JerboaException {
            curleftPattern = leftPattern;
// ======== BEGIN CODE TRANSLATION FOR EXPRESSION COMPUTATION
            // ======== SEPARATION CODE TRANSLATION FOR EXPRESSION COMPUTATION
return new 
Color(0,200,0);
// ======== END CODE TRANSLATION FOR EXPRESSION COMPUTATION
        }

        @Override
        public String getName() {
            return "color";
        }

        @Override
        public int getEmbedding() {
            return ((Modeler)modeler).getColor().getID();
        }
    }

    private class ExtrudeDartExprRn1point implements JerboaRuleExpression {

        @Override
        public Object compute(JerboaGMap gmap, JerboaRuleOperation rule,JerboaRowPattern leftPattern, JerboaRuleNode rulenode) throws JerboaException {
            curleftPattern = leftPattern;
// ======== BEGIN CODE TRANSLATION FOR EXPRESSION COMPUTATION
            // ======== SEPARATION CODE TRANSLATION FOR EXPRESSION COMPUTATION
Points res = new 
Points(n0().<jerboatutorial1.embeddings.Points>ebd(((jerboatutorial1.modeler.Modeler)modeler).getPoint().getID()),myVector);
return res;
// ======== END CODE TRANSLATION FOR EXPRESSION COMPUTATION
        }

        @Override
        public String getName() {
            return "point";
        }

        @Override
        public int getEmbedding() {
            return ((Modeler)modeler).getPoint().getID();
        }
    }

    @Override
    public boolean hasMidprocess() { return true; }
    @Override
    public boolean midprocess(JerboaGMap gmap, List<JerboaRowPattern> leftPattern) throws JerboaException {
	// BEGIN MIDPROCESS CODE
if(askUser) {
   myVector = Vectors.askForVector();
}
return true;

	// END MIDPROCESS CODE
    }

    @Override
    public boolean hasPostprocess() { return true; }
    @Override
    public void postprocess(JerboaGMap gmap, JerboaRuleResult res) throws JerboaException {
	// BEGIN POSTPROCESS CODE
askUser = true;

	// END POSTPROCESS CODE
    }

    // Facility for accessing to the dart
    private JerboaDart n0() {
        return curleftPattern.getNode(0);
    }

	public Vectors getMyVector(){
		return myVector;
	}
	public void setMyVector(Vectors _myVector){
		this.myVector = _myVector;
	}
	public boolean getAskUser(){
		return askUser;
	}
	public void setAskUser(boolean _askUser){
		this.askUser = _askUser;
	}
} // end rule Class