package jerboatutorial1.modeler;

import java.util.List;
import java.util.ArrayList;
import up.jerboa.core.rule.*;
import up.jerboa.core.util.*;
import up.jerboa.core.*;
import up.jerboa.exception.JerboaException;

import jerboatutorial1.modeler.Lesson1.CreateDart;
import jerboatutorial1.modeler.Lesson6.ExtrudeDart;
import jerboatutorial1.modeler.Lesson6.ExtrudeEdge;
import jerboatutorial1.modeler.Lesson6.ExtrudeFace;
import jerboatutorial1.modeler.Lesson1.Sew3;
import jerboatutorial1.modeler.Lesson1.Sew1;
import jerboatutorial1.modeler.Lesson1.Sew2;
import jerboatutorial1.modeler.Lesson1.Sew0;
import jerboatutorial1.modeler.Lesson1.Unsew0;
import jerboatutorial1.modeler.Lesson1.Unsew1;
import jerboatutorial1.modeler.Lesson1.Unsew2;
import jerboatutorial1.modeler.Lesson1.Unsew3;
import jerboatutorial1.modeler.a_TwoCubes;
import jerboatutorial1.modeler.Lesson2.MakeRed;
import jerboatutorial1.modeler.Lesson2.MoveVertex;
import jerboatutorial1.modeler.d_Square;
import jerboatutorial1.modeler.d_IcositeHexagon;
import jerboatutorial1.modeler.OtherRules.ChamferEdges;
import jerboatutorial1.modeler.e_Cube;
import jerboatutorial1.modeler.b_AlmostTwoCubes;
import jerboatutorial1.modeler.OtherRules.IsolateEdges;
import jerboatutorial1.modeler.OtherRules.ChamferCorners;
import jerboatutorial1.modeler.Lesson5.SubdivideEdge;
import jerboatutorial1.modeler.OtherRules.FaceToCone;
import jerboatutorial1.modeler.Lesson4.NewDart;
import jerboatutorial1.modeler.Lesson5.TriangulateFace;
import jerboatutorial1.modeler.Lesson3.MakeBlue;
import jerboatutorial1.modeler.Lesson3.MoveDown;
import jerboatutorial1.modeler.Lesson3.MakeBlueMoveDown;
import jerboatutorial1.modeler.Lesson4.Duplicate;
import jerboatutorial1.modeler.OtherRules.ChangeColor;
import jerboatutorial1.modeler.Lesson4.MedianColor;
import jerboatutorial1.modeler.OtherRules.Enlarge;
import jerboatutorial1.modeler.Lesson1.CreateDart;
import jerboatutorial1.modeler.Lesson6.ExtrudeDart;
import jerboatutorial1.modeler.Lesson6.ExtrudeEdge;
import jerboatutorial1.modeler.Lesson6.ExtrudeFace;
import jerboatutorial1.modeler.Lesson1.Sew3;
import jerboatutorial1.modeler.Lesson1.Sew1;
import jerboatutorial1.modeler.Lesson1.Sew2;
import jerboatutorial1.modeler.Lesson1.Sew0;
import jerboatutorial1.modeler.Lesson1.Unsew0;
import jerboatutorial1.modeler.Lesson1.Unsew1;
import jerboatutorial1.modeler.Lesson1.Unsew2;
import jerboatutorial1.modeler.Lesson1.Unsew3;
import jerboatutorial1.modeler.a_TwoCubes;
import jerboatutorial1.modeler.Lesson2.MakeRed;
import jerboatutorial1.modeler.Lesson2.MoveVertex;
import jerboatutorial1.modeler.d_Square;
import jerboatutorial1.modeler.d_IcositeHexagon;
import jerboatutorial1.modeler.OtherRules.ChamferEdges;
import jerboatutorial1.modeler.e_Cube;
import jerboatutorial1.modeler.b_AlmostTwoCubes;
import jerboatutorial1.modeler.OtherRules.IsolateEdges;
import jerboatutorial1.modeler.OtherRules.ChamferCorners;
import jerboatutorial1.modeler.Lesson5.SubdivideEdge;
import jerboatutorial1.modeler.OtherRules.FaceToCone;
import jerboatutorial1.modeler.Lesson4.NewDart;
import jerboatutorial1.modeler.Lesson5.TriangulateFace;
import jerboatutorial1.modeler.Lesson3.MakeBlue;
import jerboatutorial1.modeler.Lesson3.MoveDown;
import jerboatutorial1.modeler.Lesson3.MakeBlueMoveDown;
import jerboatutorial1.modeler.Lesson4.Duplicate;
import jerboatutorial1.modeler.OtherRules.ChangeColor;
import jerboatutorial1.modeler.Lesson4.MedianColor;
import jerboatutorial1.modeler.OtherRules.Enlarge;



import jerboatutorial1.Vectors;

/**
 * 
 */

public class Modeler extends JerboaModelerGeneric {

    // BEGIN LIST OF EMBEDDINGS
    protected JerboaEmbeddingInfo point;
    protected JerboaEmbeddingInfo color;
    // END LIST OF EMBEDDINGS

    // BEGIN USER DECLARATION
    // END USER DECLARATION

    public Modeler() throws JerboaException {

        super(3);

    // BEGIN USER HEAD CONSTRUCTOR TRANSLATION

    // END USER HEAD CONSTRUCTOR TRANSLATION
        point = new JerboaEmbeddingInfo("point", JerboaOrbit.orbit(1,2,3), jerboatutorial1.embeddings.Points.class);
        color = new JerboaEmbeddingInfo("color", JerboaOrbit.orbit(0,1), java.awt.Color.class);

        this.registerEbdsAndResetGMAP(point,color);

        this.registerRule(new CreateDart(this));
        this.registerRule(new ExtrudeDart(this));
        this.registerRule(new ExtrudeEdge(this));
        this.registerRule(new ExtrudeFace(this));
        this.registerRule(new Sew3(this));
        this.registerRule(new Sew1(this));
        this.registerRule(new Sew2(this));
        this.registerRule(new Sew0(this));
        this.registerRule(new Unsew0(this));
        this.registerRule(new Unsew1(this));
        this.registerRule(new Unsew2(this));
        this.registerRule(new Unsew3(this));
        this.registerRule(new a_TwoCubes(this));
        this.registerRule(new MakeRed(this));
        this.registerRule(new MoveVertex(this));
        this.registerRule(new d_Square(this));
        this.registerRule(new d_IcositeHexagon(this));
        this.registerRule(new ChamferEdges(this));
        this.registerRule(new e_Cube(this));
        this.registerRule(new b_AlmostTwoCubes(this));
        this.registerRule(new IsolateEdges(this));
        this.registerRule(new ChamferCorners(this));
        this.registerRule(new SubdivideEdge(this));
        this.registerRule(new FaceToCone(this));
        this.registerRule(new NewDart(this));
        this.registerRule(new TriangulateFace(this));
        this.registerRule(new MakeBlue(this));
        this.registerRule(new MoveDown(this));
        this.registerRule(new MakeBlueMoveDown(this));
        this.registerRule(new Duplicate(this));
        this.registerRule(new ChangeColor(this));
        this.registerRule(new MedianColor(this));
        this.registerRule(new Enlarge(this));
    }

    public final JerboaEmbeddingInfo getPoint() {
        return point;
    }

    public final JerboaEmbeddingInfo getColor() {
        return color;
    }

}
