package jerboatutorial1;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

import java.awt.Color;
import java.awt.color.*;

import fr.up.xlim.sic.ig.jerboa.trigger.tools.JerboaMonitorInfo;
import fr.up.xlim.sic.ig.jerboa.viewer.GMapViewer;
import fr.up.xlim.sic.ig.jerboa.viewer.tools.GMapViewerBridge;
import fr.up.xlim.sic.ig.jerboa.viewer.tools.GMapViewerColor;
import fr.up.xlim.sic.ig.jerboa.viewer.tools.GMapViewerPoint;
import fr.up.xlim.sic.ig.jerboa.viewer.tools.GMapViewerTuple;
import fr.up.xlim.sic.ig.jerboa.viewer.tools.JerboaMonitorInfoBridgeSerializerMonitor;
import jerboatutorial1.embeddings.Points;
import jerboatutorial1.modeler.Modeler;
import up.jerboa.core.JerboaDart;
import up.jerboa.core.JerboaEmbeddingInfo;
import up.jerboa.core.JerboaGMap;
import up.jerboa.core.JerboaOrbit;
import up.jerboa.core.util.Pair;
import up.jerboa.exception.JerboaException;
import up.jerboa.exception.JerboaGMapDuplicateException;
import up.jerboa.exception.JerboaRuntimeException;
import up.jerboa.util.serialization.EmbeddingSerializationKind;
import up.jerboa.util.serialization.JerboaSerializeException;
import up.jerboa.util.serialization.jba.JBAEmbeddingSerialization;
import up.jerboa.util.serialization.jba.JBAFormat;

public class Bridge implements GMapViewerBridge, JBAEmbeddingSerialization{
	
	private Modeler modeler;
	private JerboaEmbeddingInfo ebdColor;
	private int ebdColorID;
	
	public Bridge(Modeler modeler) {
		this.modeler = modeler;
		this.ebdColor = modeler.getColor();
		this.ebdColorID = ebdColor.getID();
	}

	@Override
	public boolean canUndo() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public GMapViewerColor colors(JerboaDart arg0) {
		Color c = (Color)arg0.ebd(ebdColorID);
		GMapViewerColor color = new GMapViewerColor(c);
		return color;
	}

	@Override
	public GMapViewerPoint coords(JerboaDart arg0) {
		Points p = (Points)arg0.ebd(modeler.getPoint().getID());
		GMapViewerPoint point = new GMapViewerPoint(p.getX(), p.getY(), p.getZ());
		return point;
	}

	@Override
	public JerboaGMap duplicate(JerboaGMap arg0) throws JerboaGMapDuplicateException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Pair<String, String>> getCommandLineHelper() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean getOrient(JerboaDart arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasColor() {
		return true;
	}

	@Override
	public boolean hasNormal() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasOrient() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void load(GMapViewer arg0, JerboaMonitorInfo arg1) {
		JerboaMonitorInfoBridgeSerializerMonitor monitor = new JerboaMonitorInfoBridgeSerializerMonitor(arg1);
		JBAFormat jbaformat = new JBAFormat(modeler, monitor, this);
		JFileChooser filec = new JFileChooser();
		FileNameExtensionFilter jbaext = new FileNameExtensionFilter("JBA file", "jba");
		filec.setFileFilter(jbaext);
		filec.addChoosableFileFilter(jbaext);
		if(filec.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
			InputStream input;
			try {
				input = new FileInputStream(filec.getSelectedFile());
				jbaformat.load(input);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (JerboaSerializeException e) {
				e.printStackTrace();
			} catch (JerboaException e) {
				e.printStackTrace();
			}
			
		}
		
		
	}

	@Override
	public GMapViewerTuple normals(JerboaDart arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean parseCommandLine(PrintStream arg0, String arg1) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void save(GMapViewer arg0, JerboaMonitorInfo arg1) {
		JerboaMonitorInfoBridgeSerializerMonitor monitor = new JerboaMonitorInfoBridgeSerializerMonitor(arg1);
		JBAFormat jbaformat = new JBAFormat(modeler, monitor, this);
		
		JFileChooser filec = new JFileChooser();
		FileNameExtensionFilter jbaext = new FileNameExtensionFilter("JBA file", "jba");
		filec.setFileFilter(jbaext);
		filec.addChoosableFileFilter(jbaext);
		if(filec.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
			try {
				OutputStream output = new FileOutputStream(filec.getSelectedFile());//How do I link to the file with the arguments?
				jbaformat.save(output);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (JerboaSerializeException e) {
				e.printStackTrace();
			} catch (JerboaException e) {
				e.printStackTrace();
			}
			
		}
		
	}

	
	// ------------------------------ factory format JBA DEBUT
	@Override
	public void completeProcess(JerboaGMap arg0, List<JerboaDart> arg1) throws JerboaException {
		
	}

	@Override
	public EmbeddingSerializationKind kind() {
		return EmbeddingSerializationKind.SAVEANDLOAD;
	}

	@Override
	public boolean manageDimension(int arg0) {
		return true;
	}

	@Override
	public JerboaEmbeddingInfo searchCompatibleEmbedding(String ebdname, JerboaOrbit ebdorbit, String ebdtype) {
		switch(ebdname) {
		case "point": return modeler.getPoint();
		case "color": return modeler.getColor();
		}
		throw new JerboaRuntimeException("Embedding not found");
	}

	@Override
	public CharSequence serialize(JerboaEmbeddingInfo ebd, Object value) {
		// SERIALIZATION SUR 1 LIGNE OBLIGATOIRE!!!!
		switch (ebd.getName()) {
		case "point": {
			Points p = (Points) value;
			return ""+p.getX()+" "+p.getY()+ " "+p.getZ();
		}
		case "color": {
			Color c = (Color) value;
			return ""+c.getRGB();
		}
		}
		throw new JerboaRuntimeException("!!!");
	}

	@Override
	public Object unserialize(JerboaEmbeddingInfo ebd, String value) {
		switch (ebd.getName()) {
		case "point" : {
			StringTokenizer st = new StringTokenizer(value);
			float x = Float.parseFloat(st.nextToken());;
			float y = Float.parseFloat(st.nextToken());;
			float z = Float.parseFloat(st.nextToken());;
			Points p = new Points(x, y, z);
			return p;
		}
		case "color" : {
			int rgb = Integer.parseInt(value);
			Color c = new Color(rgb);
			return c;
		}
		}
		throw new JerboaRuntimeException("!!!");
	}

	// ------------------------------ factory format JBA FIN

}
